/*------------------------------
 *
 * Xbg}V2
 *
 * main R[h
 * Q[̒S
 *
------------------------------*/

/*------------------------------
 * DEFINITION(`)
------------------------------*/
#define MAIN_H									// ܂Ȃ

/*------------------------------
 * INCLUDION
------------------------------*/
#include "DxLib.h"								// Dxlib wb_[

#include "main.h"								// main wb_[

#include "fight.h"								// fight wb_[
#include "fps.h"								// fps wb_[
#include "gamepad.h"							// gamepad wb_[
#include "key.h"								// key wb_[
#include "myrand.h"								// myrand wb_[
#include "player.h"								// player wb_[
#include "replay.h"								// replay wb_[

#include <io.h>									// for filefind
#include <string.h>								// for strcmp
#include <time.h>
#include <windows.h>

/*------------------------------
 * LOCAL PARAMETER
------------------------------*/
int *BGM = NULL;								// BGM
int BGM_num;

int REPLAY_T;

/*------------------------------
 * ֐ WinMain
 * vO WinMain n܂܂
------------------------------*/
int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,
						LPSTR lpCmdLine, int nCmdShow )
{

	/*------------------------------
	 * ini̐ݒ̓ǂݍ
	------------------------------*/
	FULL_SCREEN_FLAG	= GetPrivateProfileInt("General", "FULL_SCREEN", 0, "./option.ini");
	BGM_VOLUME			= GetPrivateProfileInt("General", "BGM_VOLUME", 0, "./option.ini");
	SE_VOLUME			= GetPrivateProfileInt("General", "SE_VOLUME", 0, "./option.ini");
	VOICE_VOLUME		= GetPrivateProfileInt("General", "VOICE_VOLUME", 0, "./option.ini");
	SHOW_FPS			= GetPrivateProfileInt("General", "SHOW_FPS", 0, "./option.ini");
	PLAYER_HP[0]		= GetPrivateProfileInt("Gameplay", "PLAYER1_HP", 0, "./option.ini");
	PLAYER_HP[1]		= GetPrivateProfileInt("Gameplay", "PLAYER2_HP", 0, "./option.ini");
	MOVE_CAMERA			= GetPrivateProfileInt("Gameplay", "MOVE_CAMERA", 0, "./option.ini");
	SHOW_EFFECT			= GetPrivateProfileInt("Gameplay", "SHOW_EFFECT", 0, "./option.ini");

	/*------------------------------
	 * DXCȕ
	------------------------------*/
	SetOutApplicationLogValidFlag( FALSE );		// Ȍo͂sȂ									

	if( !FULL_SCREEN_FLAG )ChangeWindowMode( TRUE ); // EBhE[hŋN

	SetGraphMode( WINDOW_WIDTH , WINDOW_HEIGHT , 32 );
												// EBhȆ傫̎w

	SetMainWindowText( WINDOW_TITLE );			// ^Cg̐ݒ

	if( DxLib_Init() == -1 )					// DXCu
	{
		return -1;								// G[N璼ɏI
	}

	SetAlwaysRunFlag( TRUE );					// EBhEANeBûƂł悤ɂB

	SetDrawScreen( DX_SCREEN_BACK );			// ʂ̕`ʐ𗠂ɐݒ

	/*------------------------------
	 * 3D֌W
	------------------------------*/
	SetCameraNearFar( 1.0f, 100.0f ); 
	SetCameraPositionAndTarget_UpVecY( VGet( -20.0f, 8.5f, 0.0f ), VGet( 0.0f, 8.5f, 0.0f ) );
												// J̐ݒ

	SetUseLighting( FALSE );					// ̌vZȂ

	gameMain();									// Q[̌Ăяo

	DxLib_End();								// cwCugp̏I

	return 0;									// \tg̏I 
}

/*------------------------------
 * ֐ gameMain
 * Q[̒
------------------------------*/
void gameMain(void)
{
	gameInit();									// Q[̏

	while( 1 )
	{
		getWaitTime();							// ҂ԎZo

		// bZ[W[vɑ鏈
		if( ProcessMessage() == -1 )
		{
			break;								// G[N烋[v𔲂
		}

		checkKeyState();						// L[̓͏Ԃ̎擾B
		checkPadState();

		if( getKeyState( KEY_INPUT_ESCAPE ) )	// EscapeL[ŏI
			break;

		/*------------------------------
		 * Q[vC̏
		------------------------------*/
		gameLoop();

		/*------------------------------
		 * Q[vC̏܂
		------------------------------*/

		if( COUNT == ULONG_MAX )				// I[o[t[΍
			COUNT = 0;
		else
			COUNT++;								// JEgAbv

		fpsTimeFunction();						// FPS̎Zo
		wait();		
	}

	gameFinal();								// Q[̏I
}

/*------------------------------
 * ֐ gameLoop
 * Q[[v
------------------------------*/
void gameLoop(void)
{
		switch( game_state )
		{
		case GAME_TITLE:
			if( player1.checkCommand2() || player2.checkCommand2() || getKeyState( KEY_INPUT_RETURN ) == 1 )
			{
				game_state = GAME_PLAYING;		// {^n܂
				fight.init( FIGHT_PLAYMODE_PLAY ); // 
				playRandomBGM();				// BGM̍Đ
				startRecordingReplay();			// vC̕ۑJn
				PlaySoundMem( SE[ SE_DECIDE ] , DX_PLAYTYPE_BACK );
				REPLAY_T = 0;
			}
			else if( getKeyState( KEY_INPUT_P ) == 1 )
			{
				if( startPlayingReplay() != -1 )
				{
					game_state = GAME_PLAYING;	// {^n܂
					fight.init( FIGHT_PLAYMODE_REPLAY ); // 
					playRandomBGM();			// BGM̍Đ
				}
				PlaySoundMem( SE[ SE_DECIDE ] , DX_PLAYTYPE_BACK );
			}
			else if( REPLAY_T++ >= 900 )
			{
				if( startPlayingReplay() != -1 )
				{
					game_state = GAME_PLAYING;	// {^n܂
					fight.init( FIGHT_PLAYMODE_DEMO ); // 
				}
				REPLAY_T = 0;
			}
			ClearDrawScreen();
			DrawBox( 0, 0, WINDOW_WIDTH, WINDOW_HEIGHT, 0xffffff, TRUE );
												// ʂ̏
			if( ( COUNT / 30 ) % 3 )			// ^Cg̕`
			{
				DrawFormatStringToHandle( 220, 225, 0xff8080, FONT_HANDLE3, "CLOSE" );
				DrawFormatStringToHandle( 220, 275, 0xff8080, FONT_HANDLE3, "FIGHTER" );
				DrawFormatStringToHandle( 220, 325, 0x8080ff, FONT_HANDLE3, "REVENGE" );
			}
			DrawFormatStringToHandle( 450, 550, 0xffffff, FONT_HANDLE2, "Version 1.00" );
			if( SHOW_FPS ) DrawFormatString( 1, 1, 0x000000, "FPS: %4.1f", getFPS() );
			ScreenFlip();	
			break;
		case GAME_PLAYING:
			fight.update();						// Abvf[g
			ClearDrawScreen();
			DrawBox( 0, 0, WINDOW_WIDTH, WINDOW_HEIGHT, 0xffffff, TRUE );
												// ʂ̏
			fight.output();						// o
			if( SHOW_FPS ) DrawFormatString( 1, 1, 0x000000, "FPS: %4.1f", getFPS() );
			ScreenFlip();	
			break;
		default:
			break;
		}	
}

/*------------------------------
 * ֐ gameInit
 * Q[̏
------------------------------*/
void gameInit(void)
{
	COUNT = 0;									// Q[JEg̏

	/*------------------------------
	 * Ԓ
	------------------------------*/
	game_state = GAME_TITLE;

	initPad();									// pbh̏

	loadPlayerGraph();							// f̃[h

	loadFAMania();								// FAManiatHg̃[h
	loadFontHandle();							// tHgnh̃[h

	loadBGM();									// TEh̃[h
	loadSE();

	MTInit( (unsigned)time(NULL) );				// MTɎ^

	fight.init( FIGHT_PLAYMODE_PLAY );

	REPLAY_T = 0;
}

/*------------------------------
 * ֐ gameFinal
 * Q[̏IɌĂяo
------------------------------*/
void gameFinal(void)
{
	stopBGM();
	endRecordingReplay();

	unloadPlayerGraph();						// f̃A[h

	unloadFAMania();							// tHg̃A[h

	unloadBGM();								// TEh̃A[h
	unloadSE();
}

/*------------------------------
 * ֐ loadFAMania,unload
 * tHg̓ǂݍ
------------------------------*/
LPCSTR font_path;								// tHg̃pX
void loadFAMania(void)
{
	font_path = "font/FAMania/FAMania2.6.TTF";
												// ǂݍރtHgt@C̃pX
	if (AddFontResourceEx(font_path, FR_PRIVATE, NULL) > 0)
	{
	}
	else
	{
		MessageBox(NULL,"tHgǍs","",MB_OK);
												// tHgǍG[
	}
}
void unloadFAMania(void)
{
	if (RemoveFontResourceEx(font_path, FR_PRIVATE, NULL))
	{
	}
	else
	{
		MessageBox(NULL, "remove failure", "", MB_OK);
	}
}

/*------------------------------
 * ֐ loadFontHandle
 * gptHgnh̃[h
------------------------------*/
void loadFontHandle(void)
{
	FONT_HANDLE1 = CreateFontToHandle( "FAMania", 16, 1, DX_FONTTYPE_EDGE, -1, 1 );
	FONT_HANDLE2 = CreateFontToHandle( "FAMania", 20, 1, DX_FONTTYPE_EDGE, -1, 2 );
	FONT_HANDLE3 = CreateFontToHandle( "FAMania", 40, 1, DX_FONTTYPE_EDGE, -1, 2 );
	FONT_HANDLE4 = CreateFontToHandle( "FAMania", 80, 1, DX_FONTTYPE_EDGE, -1, 4 );
}

/*------------------------------
 * ֐ loadBGM, unload
 * BGM̃[h, A[h
------------------------------*/
void loadBGM(void)
{
	if( !BGM )
		BGM = new int[50];

	for(int i=0;i<50;i++)
		BGM[ i ] = -1;

	SetCreateSoundDataType( DX_SOUNDDATATYPE_FILE ) ;
											// BGM̓Xg[~OĐ(Ăяo)Ƃɂ

	struct _finddata_t c_file;
	long   hFile;

	BGM_num = 0;
	char file_path[256];

	/*------------------------------
	 * sound/bgm fBNgmp3t@CT܂B
	------------------------------*/
	if( (hFile = _findfirst( "sound/bgm/*.mp3", &c_file )) == -1L )
	{
		/*------------------------------
		 * t@CȂƂ
		------------------------------*/
	}
	else
	{
		/*------------------------------
		 * t@CI
		------------------------------*/	
		// t@CpX̎Zo
		strcpy( file_path, "sound/bgm/" );
		strcat( file_path, c_file.name );

		// t@C̓ǂݍ
		BGM[ BGM_num ] = LoadSoundMem( file_path );
		// ʒ
		ChangeVolumeSoundMem( 256 * BGM_VOLUME / 100, BGM[ BGM_num ] );

		// JE^
		BGM_num++;

		// c̃t@CT܂
		while( _findnext( hFile, &c_file ) == 0 )
		{
			// t@CpX̎Zo
			strcpy( file_path, "sound/bgm/" );
			strcat( file_path, c_file.name );

			// t@C̓ǂݍ
			BGM[ BGM_num ] = LoadSoundMem( file_path );
			// ʒ
			ChangeVolumeSoundMem( 256 * BGM_VOLUME / 100, BGM[ BGM_num ] );

			// JE^
			BGM_num++;

			if( BGM_num >= 50 ) break;
		}

		_findclose( hFile );
	}
	/*------------------------------
	 * sound/bgm fBNgoggt@CT܂B
	------------------------------*/
	if( (hFile = _findfirst( "sound/bgm/*.ogg", &c_file )) == -1L )
	{
		/*------------------------------
		 * t@CȂƂ
		------------------------------*/
	}
	else
	{
		/*------------------------------
		 * t@CI
		------------------------------*/	
		// t@CpX̎Zo
		strcpy( file_path, "sound/bgm/" );
		strcat( file_path, c_file.name );

		// t@C̓ǂݍ
		BGM[ BGM_num ] = LoadSoundMem( file_path );
		// ʒ
		ChangeVolumeSoundMem( 256 * BGM_VOLUME / 100, BGM[ BGM_num ] );

		// JE^
		BGM_num++;

		// c̃t@CT܂
		while( _findnext( hFile, &c_file ) == 0 )
		{
			// t@CpX̎Zo
			strcpy( file_path, "sound/bgm/" );
			strcat( file_path, c_file.name );

			// t@C̓ǂݍ
			BGM[ BGM_num ] = LoadSoundMem( file_path );
			// ʒ
			ChangeVolumeSoundMem( 256 * BGM_VOLUME / 100, BGM[ BGM_num ] );

			// JE^
			BGM_num++;

			if( BGM_num >= 50 ) break;
		}

		_findclose( hFile );
	}
}
void unloadBGM(void)
{
	for(int i=0;i<BGM_num;i++)
	{
		if( BGM[ i ] != -1 )
			DeleteSoundMem( BGM[ i ] );
	}

	if( BGM )
	{
		delete [] BGM;	// |C^w
		BGM = NULL;
		BGM_num = 0;
	}
}

/*------------------------------
 * ֐ loadSE, unloadSE
 * ʉ̃[h, A[h
------------------------------*/
void loadSE(void)
{
	SetCreateSoundDataType( DX_SOUNDDATATYPE_MEMNOPRESS ) ;
											// SE͊Sɓǂݍݐ؂

	SE = new int[50];

	for(int i=0;i<50;i++)
		SE[ i ] = -1;

	// {CX
	SE[ SE_DOUBLEKO ] =		LoadSoundMem( "sound/se/voice/doubleKO.wav" );
	SE[ SE_FIGHT ] =		LoadSoundMem( "sound/se/voice/fight.wav" );
	SE[ SE_FINALROUND ] =	LoadSoundMem( "sound/se/voice/finalround.wav" );
	SE[ SE_KO ] =			LoadSoundMem( "sound/se/voice/KO.wav" );
	SE[ SE_ROUND1 ] =		LoadSoundMem( "sound/se/voice/round1.wav" );
	SE[ SE_ROUND2 ] =		LoadSoundMem( "sound/se/voice/round2.wav" );
	SE[ SE_ROUND3 ] =		LoadSoundMem( "sound/se/voice/round3.wav" );
	SE[ SE_ROUND4 ] =		LoadSoundMem( "sound/se/voice/round4.wav" );
	SE[ SE_ROUND5 ] =		LoadSoundMem( "sound/se/voice/round5.wav" );
	SE[ SE_ROUND6 ] =		LoadSoundMem( "sound/se/voice/round6.wav" );
	SE[ SE_ROUND7 ] =		LoadSoundMem( "sound/se/voice/round7.wav" );
	SE[ SE_ROUND8 ] =		LoadSoundMem( "sound/se/voice/round8.wav" );
	SE[ SE_REDWIN ] =		LoadSoundMem( "sound/se/voice/redwin.wav" );
	SE[ SE_BLUEWIN ] =		LoadSoundMem( "sound/se/voice/bluewin.wav" );
	SE[ SE_TIMEUP ] =		LoadSoundMem( "sound/se/voice/timeup.wav" );
	SE[ SE_PERFECT ] =		LoadSoundMem( "sound/se/voice/perfect.wav" );

	// U, ̑
	SE[ SE_JAB ] =			LoadSoundMem( "sound/se/attack/jab.wav" );
	SE[ SE_STRAIGHT ] =		LoadSoundMem( "sound/se/attack/straight.wav" );
	SE[ SE_HOOK ] =			LoadSoundMem( "sound/se/attack/hook.wav" );
	SE[ SE_UPPER ] =		LoadSoundMem( "sound/se/attack/uppercut.wav" );
	SE[ SE_UPPERAIR ] =		LoadSoundMem( "sound/se/attack/air.wav" );
	SE[ SE_GUARD ] =		LoadSoundMem( "sound/se/attack/guard.wav" );
	SE[ SE_DOWN ] =			LoadSoundMem( "sound/se/attack/down.wav" );

	// ZNg
	SE[ SE_CURSOR ] =		LoadSoundMem( "sound/se/select/cursor.wav" );
	SE[ SE_DECIDE ] =		LoadSoundMem( "sound/se/select/decide.wav" );

	ChangeVolumeSoundMem( 256 * VOICE_VOLUME / 100, SE[ SE_DOUBLEKO ] );
	ChangeVolumeSoundMem( 256 * VOICE_VOLUME / 100, SE[ SE_FIGHT ] );
	ChangeVolumeSoundMem( 256 * VOICE_VOLUME / 100, SE[ SE_FINALROUND ] );
	ChangeVolumeSoundMem( 256 * VOICE_VOLUME / 100, SE[ SE_KO ] );
	ChangeVolumeSoundMem( 256 * VOICE_VOLUME / 100, SE[ SE_ROUND1 ] );
	ChangeVolumeSoundMem( 256 * VOICE_VOLUME / 100, SE[ SE_ROUND2 ] );
	ChangeVolumeSoundMem( 256 * VOICE_VOLUME / 100, SE[ SE_ROUND3 ] );
	ChangeVolumeSoundMem( 256 * VOICE_VOLUME / 100, SE[ SE_ROUND4 ] );
	ChangeVolumeSoundMem( 256 * VOICE_VOLUME / 100, SE[ SE_ROUND5 ] );
	ChangeVolumeSoundMem( 256 * VOICE_VOLUME / 100, SE[ SE_ROUND6 ] );
	ChangeVolumeSoundMem( 256 * VOICE_VOLUME / 100, SE[ SE_ROUND7 ] );
	ChangeVolumeSoundMem( 256 * VOICE_VOLUME / 100, SE[ SE_ROUND8 ] );
	ChangeVolumeSoundMem( 256 * VOICE_VOLUME / 100, SE[ SE_REDWIN ] );
	ChangeVolumeSoundMem( 256 * VOICE_VOLUME / 100, SE[ SE_BLUEWIN ] );
	ChangeVolumeSoundMem( 256 * VOICE_VOLUME / 100, SE[ SE_TIMEUP ] );
	ChangeVolumeSoundMem( 256 * VOICE_VOLUME / 100, SE[ SE_PERFECT ] );


	ChangeVolumeSoundMem( 256 * SE_VOLUME / 100, SE[ SE_JAB ] );
	ChangeVolumeSoundMem( 256 * SE_VOLUME / 100, SE[ SE_STRAIGHT ] );
	ChangeVolumeSoundMem( 256 * SE_VOLUME / 100, SE[ SE_HOOK ] );
	ChangeVolumeSoundMem( 256 * SE_VOLUME / 100, SE[ SE_UPPER ] );
	ChangeVolumeSoundMem( 256 * SE_VOLUME / 100, SE[ SE_UPPERAIR ] );
	ChangeVolumeSoundMem( 256 * SE_VOLUME / 100, SE[ SE_GUARD ] );
	ChangeVolumeSoundMem( 256 * SE_VOLUME / 100, SE[ SE_DOWN ] );
	ChangeVolumeSoundMem( 256 * SE_VOLUME / 100, SE[ SE_CURSOR ] );
	ChangeVolumeSoundMem( 256 * SE_VOLUME / 100, SE[ SE_DECIDE ] );

}
void unloadSE(void)
{
	if( !SE ) return;

	for(int i=0;i<50;i++)
	{
		if( SE[ i ] != -1 )
			DeleteSoundMem( SE[ i ] );
	}

	delete [] SE;	// |C^w
	SE = NULL;
}

/*------------------------------
 * ֐ playRandomBGM, playSelectBGM, stopBGM
 * BGM̍Đƒ~
------------------------------*/
void playRandomBGM(void)
{
	if( BGM_num > 0 )
		PlaySoundMem( BGM[ getIntRand( 0, BGM_num - 1 ) ], DX_PLAYTYPE_LOOP );
}
void stopBGM(void)
{
	for(int i=0;i<BGM_num;i++)
		StopSoundMem( BGM[ i ] );	
}